Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCProvider.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCProvider.java	(revision 43920)
@@ -23,11 +23,7 @@
  */
 package org.gvsig.exportto.swing.prov.jdbc;
 
-import java.util.ArrayList;
-import java.util.List;
-import org.cresques.cts.IProjection;
 import org.gvsig.exportto.ExporttoService;
-import org.gvsig.exportto.swing.prov.jdbc.panel.CheckGeometriesPanel;
 import org.gvsig.exportto.swing.prov.jdbc.panel.GeometryIndexPanel;
 import org.gvsig.exportto.swing.prov.jdbc.panel.IdentifiersOptionsPanel;
 import org.gvsig.exportto.swing.prov.jdbc.panel.JDBCConnectionPanel;
@@ -36,15 +32,15 @@
 import org.gvsig.exportto.swing.prov.jdbc.panel.PostCreatingStatementPanel;
 import org.gvsig.exportto.swing.prov.jdbc.panel.SelectPkPanel;
 import org.gvsig.exportto.swing.prov.jdbc.panel.SelectTableNamePanel;
+import org.gvsig.exportto.swing.spi.AbstractExporttoSwingProvider;
 import org.gvsig.exportto.swing.spi.ExporttoSwingProvider;
-import org.gvsig.exportto.swing.spi.ExporttoSwingProviderPanel;
+import org.gvsig.exportto.swing.spi.panels.CheckGeometriesPanel;
 import org.gvsig.fmap.dal.DALLocator;
 import org.gvsig.fmap.dal.DataManager;
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorer;
 import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
-import org.gvsig.tools.service.spi.AbstractProvider;
 import org.gvsig.tools.service.spi.ProviderServices;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
@@ -55,34 +51,21 @@
  * @author gvSIG Team
  * @version $Id$
  */
-public class BaseExporttoJDBCProvider extends AbstractProvider
-        implements ExporttoJDBCOptions, ExporttoSwingProvider {
+public class BaseExporttoJDBCProvider 
+        extends AbstractExporttoSwingProvider
+        implements ExporttoSwingProvider {
 
-    private static Logger logger = LoggerFactory.getLogger(
+    private static final Logger logger = LoggerFactory.getLogger(
             BaseExporttoJDBCProvider.class);
 
-    protected List<ExporttoSwingProviderPanel> panels = new ArrayList<ExporttoSwingProviderPanel>();
-
-    protected FeatureStore sourceStore;
-    protected IProjection projection;
-    private final JDBCConnectionPanel connectionPanel;
-    private final SelectPkPanel selectPkPanel;
-    private final SelectTableNamePanel selectTableNamePanel;
-    private final CheckGeometriesPanel checkGeometriesPanel;
-    private final IdentifiersOptionsPanel identifiersOptionsPanel;
-
-    private final GeometryIndexPanel geometryIndexPanel;
-    private final UpdateTableStatisticsPanel updateTableStatistics;
-    private final PermissionsPanel permissionsPanel;
-    private final PostCreatingStatementPanel postCreatingStatementPanel;
-
     private String storeName = null;
 
-    public BaseExporttoJDBCProvider(ProviderServices providerServices,
-            FeatureStore sourceStore, IProjection projection) {
-        super(providerServices);
-        this.sourceStore = sourceStore;
-        this.projection = projection;
+    @SuppressWarnings("OverridableMethodCallInConstructor")
+    public BaseExporttoJDBCProvider(
+            ProviderServices providerServices,
+            FeatureStore sourceStore
+        ) {
+        super(providerServices, sourceStore);
 
         FeatureType ftype = null;
         try {
@@ -91,103 +74,40 @@
             logger.warn("Can't retrieve the feature type to use in the export to JDBC panel.", exc);
 
         }
-        this.connectionPanel = new JDBCConnectionPanel(this);
-        this.selectTableNamePanel = new SelectTableNamePanel(this);
-        this.selectPkPanel = new SelectPkPanel(this);
-        this.checkGeometriesPanel = new CheckGeometriesPanel(this);
-        this.identifiersOptionsPanel = new IdentifiersOptionsPanel(this);
+        this.panelAdd(new IdentifiersOptionsPanel(this.getOptions()));
+        this.panelAdd(new JDBCConnectionPanel(this.getOptions()));
+        this.panelAdd(new SelectTableNamePanel(this.getOptions()));
+        this.panelAdd(new SelectPkPanel(this.getOptions()));
+        this.panelAdd(new GeometryIndexPanel(this.getOptions()));
+        this.panelAdd(new CheckGeometriesPanel(this.getOptions()));
+        this.panelAdd(new PermissionsPanel(this.getOptions()));
+        this.panelAdd(new UpdateTableStatisticsPanel(this.getOptions()));
+        this.panelAdd(new PostCreatingStatementPanel(this.getOptions()));
 
-        this.geometryIndexPanel = new GeometryIndexPanel(this);
-        this.updateTableStatistics = new UpdateTableStatisticsPanel(this);
-        this.permissionsPanel = new PermissionsPanel(this);
-        this.postCreatingStatementPanel = new PostCreatingStatementPanel(this);
-
-        this.panels.add(this.identifiersOptionsPanel);
-        this.panels.add(this.connectionPanel);
-        this.panels.add(this.selectTableNamePanel);
-        this.panels.add(this.selectPkPanel);
-        this.panels.add(this.geometryIndexPanel);
-        this.panels.add(this.checkGeometriesPanel);
-
-        this.panels.add(this.permissionsPanel);
-        this.panels.add(this.updateTableStatistics);
-        this.panels.add(this.postCreatingStatementPanel);
-
     }
 
-
-
-    public int getPanelCount() {
-        return this.panels.size();
+    
+    @Override
+    public ExporttoJDBCOptions getOptions() {
+        if( this.options == null ) {
+            this.options = new BaseExporttoJDBCOptions();                    
+        }
+        return (ExporttoJDBCOptions) this.options;
     }
 
-    public ExporttoSwingProviderPanel getPanelAt(int index) {
-        return this.panels.get(index);
-    }
-
-    public FeatureStore getSource() {
-        return this.sourceStore;
-    }
-
+    @Override
     public ExporttoService createExporttoService() {
-        JDBCServerExplorerParameters explorerParameters = this.getExplorerParameters();
-        explorerParameters.setSchema(this.getSchema());
-        return new ExporrtoJDBCService(this);
+        ExporttoJDBCOptions theOptions = this.getOptions();
+        JDBCServerExplorerParameters explorerParameters = theOptions.getExplorerParameters();
+        explorerParameters.setSchema(theOptions.getSchema());
+        return new ExporrtoJDBCService(theOptions);
     }
 
-    @Override
-    public boolean getTranslateIdentifiersToLowerCase() {
-        return this.identifiersOptionsPanel.getTranslateToLowerCase();
-    }
 
-    public boolean getTranslateHyphens() {
-        return this.identifiersOptionsPanel.getTranslateHyphens();
-    }
-
-    public boolean getRemoveSpacesInIdentifiers() {
-        return this.identifiersOptionsPanel.getRemoveSpacesInTableName();
-    }
-
-    public JDBCServerExplorerParameters getExplorerParameters() {
-        return this.connectionPanel.getServerExplorerParameters();
-    }
-
-    public String getSchema() {
-        return this.selectTableNamePanel.getSchema();
-    }
-
-    public String getTableName() {
-        return this.selectTableNamePanel.getTableName();
-    }
-
-    public boolean canCreatetable() {
-        return this.selectTableNamePanel.canCreateTable();
-    }
-
-    public String getPrimaryKey() {
-        return this.selectPkPanel.getPrimaryKeyName();
-    }
-
-    public int getGeometryChecks() {
-        return this.checkGeometriesPanel.getGeometryChecks();
-    }
-
-    public int getGeometryChecksAction() {
-        return this.checkGeometriesPanel.getGeometryChecksAction();
-    }
-
-    public boolean getTryToFixGeometry() {
-        return this.checkGeometriesPanel.getTryToFixGeometry();
-    }
-
-    public String getExplorerName() {
-        return this.connectionPanel.getServerExplorerParameters().getExplorerName();
-    }
-
     public String getStoreName() {
         if ( this.storeName == null ) {
             try {
-                JDBCServerExplorerParameters explorerParameters = this.getExplorerParameters();
+                JDBCServerExplorerParameters explorerParameters = this.getOptions().getExplorerParameters();
                 if ( explorerParameters == null ) {
                     return null;
                 }
@@ -205,67 +125,12 @@
         return this.storeName;
     }
 
-    public IProjection getTargetProjection() {
-        return this.projection;
-    }
-
-    public String getSelectRole() {
-        return this.permissionsPanel.getSelectRole();
-    }
-
-    public String getInsertRole() {
-        return this.permissionsPanel.getInsertRole();
-    }
-
-    public String getUpdateRole() {
-        return this.permissionsPanel.getUpdateRole();
-    }
-
-    public String getDeleteRole() {
-        return this.permissionsPanel.getDeleteRole();
-    }
-
-    public String getTruncateRole() {
-        return this.permissionsPanel.getTruncateRole();
-    }
-
-    public String getReferenceRole() {
-        return this.permissionsPanel.getReferenceRole();
-    }
-
-    public String getTriggerRole() {
-        return this.permissionsPanel.getTriggerRole();
-    }
-
-    public String getAllRole() {
-        return this.permissionsPanel.getAllRole();
-    }
-
-    public String getPostCreatingStatement() {
-        return this.postCreatingStatementPanel.getPostCreatingStatement();
-    }
-
-    public boolean getCreateIndexInGeometryRow() {
-        return this.geometryIndexPanel.getCreateIndexInGeometryRow();
-    }
-
-    public boolean getUpdateTableStatistics() {
-        return this.updateTableStatistics.getUpdateTableStatistics();
-    }
-
     /**
-     * Sets the target projection to which should be exported
-     * @param targetProjection
-     */
-    public void setTargetProjection(IProjection targetProjection){
-        this.projection=targetProjection;
-    }
-
-    /**
      * Informs if it needs to ask for a target projection,
      * or if it is not needed or provided through its own wizard panel.
      * @return
      */
+    @Override
     public boolean needsPanelTargetProjection(){
         return true;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCOptions.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCOptions.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCOptions.java	(revision 43920)
@@ -0,0 +1,379 @@
+/*
+ * To change this license header, choose License Headers in Project Properties.
+ * To change this template file, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package org.gvsig.exportto.swing.prov.jdbc;
+
+import org.gvsig.exportto.swing.spi.options.BaseExportGeometryOptions;
+import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class BaseExporttoJDBCOptions 
+        extends BaseExportGeometryOptions
+        implements ExporttoJDBCOptions
+    {
+
+    private JDBCServerExplorerParameters explorerParameters;
+    private String schema;
+    private String tableName;
+    private boolean canCreatetable;
+    private String primaryKey;
+    private String storeName;
+    private String explorerName;
+    private boolean translateIdentifiersToLowerCase;
+    private boolean removeSpacesInIdentifiers;
+    private boolean translateHyphens;
+    private String selectRole;
+    private String insertRole;
+    private String updateRole;
+    private String deleteRole;
+    private String truncateRole;
+    private String referenceRole;
+    private String triggerRole;
+    private String allRole;
+    private String postCreatingStatement;
+    private boolean createIndexInGeometryRow;
+    private boolean updateTableStatistics;
+    private String primaryKeyName;
+
+    /**
+     * @return the explorerParameters
+     */
+    @Override
+    public JDBCServerExplorerParameters getExplorerParameters() {
+        return explorerParameters;
+    }
+
+    /**
+     * @param explorerParameters the explorerParameters to set
+     */
+    @Override
+    public void setExplorerParameters(JDBCServerExplorerParameters explorerParameters) {
+        this.explorerParameters = explorerParameters;
+    }
+
+    /**
+     * @return the schema
+     */
+    @Override
+    public String getSchema() {
+        return schema;
+    }
+
+    /**
+     * @param schema the schema to set
+     */
+    @Override
+    public void setSchema(String schema) {
+        this.schema = schema;
+    }
+
+    /**
+     * @return the tableName
+     */
+    @Override
+    public String getTableName() {
+        return tableName;
+    }
+
+    /**
+     * @param tableName the tableName to set
+     */
+    @Override
+    public void setTableName(String tableName) {
+        this.tableName = tableName;
+    }
+
+    /**
+     * @return the canCreatetable
+     */
+    @Override
+    public boolean canCreatetable() {
+        return canCreatetable;
+    }
+
+    /**
+     * @param canCreatetable the canCreatetable to set
+     */
+    @Override
+    public void setCanCreatetable(boolean canCreatetable) {
+        this.canCreatetable = canCreatetable;
+    }
+
+    /**
+     * @return the primaryKey
+     */
+    @Override
+    public String getPrimaryKey() {
+        return primaryKey;
+    }
+
+    /**
+     * @param primaryKey the primaryKey to set
+     */
+    @Override
+    public void setPrimaryKey(String primaryKey) {
+        this.primaryKey = primaryKey;
+    }
+
+    /**
+     * @return the storeName
+     */
+    @Override
+    public String getStoreName() {
+        return storeName;
+    }
+
+    /**
+     * @param storeName the storeName to set
+     */
+    @Override
+    public void setStoreName(String storeName) {
+        this.storeName = storeName;
+    }
+
+    /**
+     * @return the explorerName
+     */
+    @Override
+    public String getExplorerName() {
+        return explorerName;
+    }
+
+    /**
+     * @param explorerName the explorerName to set
+     */
+    @Override
+    public void setExplorerName(String explorerName) {
+        this.explorerName = explorerName;
+    }
+
+    /**
+     * @return the translateIdentifiersToLowerCase
+     */
+    @Override
+    public boolean getTranslateIdentifiersToLowerCase() {
+        return translateIdentifiersToLowerCase;
+    }
+
+    /**
+     * @param translateIdentifiersToLowerCase the translateIdentifiersToLowerCase to set
+     */
+    @Override
+    public void setTranslateIdentifiersToLowerCase(boolean translateIdentifiersToLowerCase) {
+        this.translateIdentifiersToLowerCase = translateIdentifiersToLowerCase;
+    }
+
+    /**
+     * @return the removeSpacesInIdentifiers
+     */
+    @Override
+    public boolean getRemoveSpacesInIdentifiers() {
+        return removeSpacesInIdentifiers;
+    }
+
+    /**
+     * @param removeSpacesInIdentifiers the removeSpacesInIdentifiers to set
+     */
+    @Override
+    public void setRemoveSpacesInIdentifiers(boolean removeSpacesInIdentifiers) {
+        this.removeSpacesInIdentifiers = removeSpacesInIdentifiers;
+    }
+
+    /**
+     * @return the translateHyphens
+     */
+    @Override
+    public boolean getTranslateHyphens() {
+        return translateHyphens;
+    }
+
+    /**
+     * @param translateHyphens the translateHyphens to set
+     */
+    @Override
+    public void setTranslateHyphens(boolean translateHyphens) {
+        this.translateHyphens = translateHyphens;
+    }
+
+    /**
+     * @return the selectRole
+     */
+    @Override
+    public String getSelectRole() {
+        return selectRole;
+    }
+
+    /**
+     * @param selectRole the selectRole to set
+     */
+    @Override
+    public void setSelectRole(String selectRole) {
+        this.selectRole = selectRole;
+    }
+
+    /**
+     * @return the insertRole
+     */
+    @Override
+    public String getInsertRole() {
+        return insertRole;
+    }
+
+    /**
+     * @param insertRole the insertRole to set
+     */
+    @Override
+    public void setInsertRole(String insertRole) {
+        this.insertRole = insertRole;
+    }
+
+    /**
+     * @return the updateRole
+     */
+    @Override
+    public String getUpdateRole() {
+        return updateRole;
+    }
+
+    /**
+     * @param updateRole the updateRole to set
+     */
+    @Override
+    public void setUpdateRole(String updateRole) {
+        this.updateRole = updateRole;
+    }
+
+    /**
+     * @return the deleteRole
+     */
+    @Override
+    public String getDeleteRole() {
+        return deleteRole;
+    }
+
+    /**
+     * @param deleteRole the deleteRole to set
+     */
+    @Override
+    public void setDeleteRole(String deleteRole) {
+        this.deleteRole = deleteRole;
+    }
+
+    /**
+     * @return the truncateRole
+     */
+    @Override
+    public String getTruncateRole() {
+        return truncateRole;
+    }
+
+    /**
+     * @param truncateRole the truncateRole to set
+     */
+    @Override
+    public void setTruncateRole(String truncateRole) {
+        this.truncateRole = truncateRole;
+    }
+
+    /**
+     * @return the referenceRole
+     */
+    @Override
+    public String getReferenceRole() {
+        return referenceRole;
+    }
+
+    /**
+     * @param referenceRole the referenceRole to set
+     */
+    @Override
+    public void setReferenceRole(String referenceRole) {
+        this.referenceRole = referenceRole;
+    }
+
+    /**
+     * @return the triggerRole
+     */
+    @Override
+    public String getTriggerRole() {
+        return triggerRole;
+    }
+
+    /**
+     * @param triggerRole the triggerRole to set
+     */
+    @Override
+    public void setTriggerRole(String triggerRole) {
+        this.triggerRole = triggerRole;
+    }
+
+    /**
+     * @return the allRole
+     */
+    @Override
+    public String getAllRole() {
+        return allRole;
+    }
+
+    /**
+     * @param allRole the allRole to set
+     */
+    @Override
+    public void setAllRole(String allRole) {
+        this.allRole = allRole;
+    }
+
+    /**
+     * @return the postCreatingStatement
+     */
+    @Override
+    public String getPostCreatingStatement() {
+        return postCreatingStatement;
+    }
+
+    /**
+     * @param postCreatingStatement the postCreatingStatement to set
+     */
+    @Override
+    public void setPostCreatingStatement(String postCreatingStatement) {
+        this.postCreatingStatement = postCreatingStatement;
+    }
+
+    /**
+     * @return the createIndexInGeometryRow
+     */
+    @Override
+    public boolean getCreateIndexInGeometryRow() {
+        return createIndexInGeometryRow;
+    }
+
+    /**
+     * @param createIndexInGeometryRow the createIndexInGeometryRow to set
+     */
+    @Override
+    public void setCreateIndexInGeometryRow(boolean createIndexInGeometryRow) {
+        this.createIndexInGeometryRow = createIndexInGeometryRow;
+    }
+
+    /**
+     * @return the updateTableStatistics
+     */
+    @Override
+    public boolean getUpdateTableStatistics() {
+        return updateTableStatistics;
+    }
+
+    /**
+     * @param updateTableStatistics the updateTableStatistics to set
+     */
+    @Override
+    public void setUpdateTableStatistics(boolean updateTableStatistics) {
+        this.updateTableStatistics = updateTableStatistics;
+    }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/UpdateTableStatisticsPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/UpdateTableStatisticsPanel.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/UpdateTableStatisticsPanel.java	(revision 43920)
@@ -12,10 +12,10 @@
 public class UpdateTableStatisticsPanel extends UpdateTableStatisticsPanelLayout implements ExporttoSwingProviderPanel {
     private static final long serialVersionUID = -8450431632002084194L;
 
-    private ExporttoJDBCOptions provider;
+    private ExporttoJDBCOptions options;
 
-    public UpdateTableStatisticsPanel(ExporttoJDBCOptions provider) {
-        this.provider = provider;
+    public UpdateTableStatisticsPanel(ExporttoJDBCOptions options) {
+        this.options = options;
         initComponents();
     }
 
@@ -32,19 +32,24 @@
         this.chkUpdateStatisticsTableAfterInserts.setText(i18nManager.getTranslation("_Recalcular_estadisticas_de_la_tabla_al_terminar"));
     }
 
+    @Override
     public String getPanelTitle() {
         I18nManager i18nManager = ToolsLocator.getI18nManager();
         return i18nManager.getTranslation("_update_table_statistics");    
     }
 
+    @Override
     public boolean isValidPanel() throws ExporttoPanelValidationException {
+        this.options.setUpdateTableStatistics(this.getUpdateTableStatistics());
         return true;
     }
     
+    @Override
     public void enterPanel() {
         // Default do nothing
     }
     
+    @Override
     public JComponent asJComponent() {
         return this;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/SelectPkPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/SelectPkPanel.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/SelectPkPanel.java	(revision 43920)
@@ -32,7 +32,6 @@
 
 import org.gvsig.exportto.swing.spi.ExporttoPanelValidationException;
 import org.gvsig.exportto.swing.spi.ExporttoSwingProviderPanel;
-import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.i18n.I18nManager;
@@ -46,10 +45,11 @@
 
     private static final long serialVersionUID = 2652404227373508779L;
 
-    private final ExporttoJDBCOptions provider;
+    private final ExporttoJDBCOptions options;
 
-    public SelectPkPanel(ExporttoJDBCOptions provider) {
-        this.provider = provider;
+    @SuppressWarnings("OverridableMethodCallInConstructor")
+    public SelectPkPanel(ExporttoJDBCOptions options) {
+        this.options = options;
         initComponents();
     }
 
@@ -128,22 +128,19 @@
 
     @Override
     public boolean isValidPanel() throws ExporttoPanelValidationException {
+        this.options.setPrimaryKey(this.getPrimaryKeyName());
         return true;
     }
     
     private boolean hasSourcePrimaryKey() {
-        try {
-            FeatureType featureType = this.provider.getSource().getDefaultFeatureType();
-            return ! ArrayUtils.isEmpty(featureType.getPrimaryKey());
-        } catch (Exception ex) {
-            return false;
-        }
+        FeatureType featureType = this.options.getSourceFeatureType();
+        return ! ArrayUtils.isEmpty(featureType.getPrimaryKey());
     }
 
     @Override
     public void enterPanel() {
         this.fillListOfFields();
-        if( !this.provider.canCreatetable() ) {
+        if( !this.options.canCreatetable() ) {
             this.rdoCreatePrimaryNewKey.setEnabled(false);
             this.rdoUseExistingFieldAsPrimariKey.setEnabled(false);
             this.rdoDoNotCreatePrimaryKey.setEnabled(false);
@@ -175,8 +172,7 @@
 
     private void fillListOfFields() {
         try {
-            FeatureStore source = this.provider.getSource();
-            FeatureType sourceFeatureType = source.getDefaultFeatureType();
+            FeatureType sourceFeatureType = this.options.getSourceFeatureType();
             DefaultListModel model = new DefaultListModel();
             for (int i = 0; i < sourceFeatureType.size(); i++) {
                 model.addElement(sourceFeatureType.getAttributeDescriptor(i).getName());
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/PermissionsPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/PermissionsPanel.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/PermissionsPanel.java	(revision 43920)
@@ -15,15 +15,16 @@
 public class PermissionsPanel extends PermissionsPanelLayout implements ExporttoSwingProviderPanel {
     private static final long serialVersionUID = -1930610404012797310L;
 
-    private ExporttoJDBCOptions provider;
+    private final ExporttoJDBCOptions options;
 
-    public PermissionsPanel(ExporttoJDBCOptions provider) {
-        this.provider = provider;
+    public PermissionsPanel(ExporttoJDBCOptions options) {
+        this.options = options;
         initComponents();
     }
 
     private void initComponents() {
         ActionListener listener = new ActionListener() {
+            @Override
             public void actionPerformed(ActionEvent ae) {
                 doUpdateState();
             }
@@ -71,17 +72,28 @@
         this.txtRoleReference.setEnabled(this.chkReference.isSelected());
     }
     
+    @Override
     public String getPanelTitle() {
         I18nManager i18nManager = ToolsLocator.getI18nManager();
         return i18nManager.getTranslation("_Permissions");    
     }
 
+    @Override
     public boolean isValidPanel() throws ExporttoPanelValidationException {
+        this.options.setAllRole(this.getAllRole());
+        this.options.setDeleteRole(this.getDeleteRole());
+        this.options.setInsertRole(this.getInsertRole());
+        this.options.setReferenceRole(this.getReferenceRole());
+        this.options.setSelectRole(this.getSelectRole());
+        this.options.setTriggerRole(this.getTriggerRole());
+        this.options.setTruncateRole(this.getTruncateRole());
+        this.options.setUpdateRole(this.getUpdateRole());
         return true;
     }
     
+    @Override
     public void enterPanel() {
-        boolean enabled = this.provider.canCreatetable();
+        boolean enabled = this.options.canCreatetable();
         this.chkAll.setEnabled(enabled);
         this.chkSelect.setEnabled(enabled);
         this.chkUpdate.setEnabled(enabled);
@@ -92,6 +104,7 @@
         this.chkReference.setEnabled(enabled);
     }
     
+    @Override
     public JComponent asJComponent() {
         return this;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/IdentifiersOptionsPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/IdentifiersOptionsPanel.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/IdentifiersOptionsPanel.java	(revision 43920)
@@ -20,10 +20,10 @@
 public class IdentifiersOptionsPanel extends IdentifiersOptionsPanelView implements ExporttoSwingProviderPanel {
     private static final long serialVersionUID = -6390855050271511346L;
 
-    private final ExporttoJDBCOptions provider;
+    private final ExporttoJDBCOptions options;
 
-    public IdentifiersOptionsPanel(ExporttoJDBCOptions provider) {
-        this.provider = provider;
+    public IdentifiersOptionsPanel(ExporttoJDBCOptions options) {
+        this.options = options;
         initComponents();
     }
 
@@ -51,6 +51,9 @@
 
     @Override
     public boolean isValidPanel() throws ExporttoPanelValidationException {
+        this.options.setRemoveSpacesInIdentifiers(this.chkRemoveSpaces.isSelected());
+        this.options.setTranslateIdentifiersToLowerCase(this.chkTraslateToLowerCase.isSelected());
+        this.options.setTranslateHyphens(this.chkTraslateHyphens.isSelected());
         return true;
     }
 
